package mtv.gui;

import mtv.core.Test;
import java.util.Observer;
import javax.swing.border.TitledBorder;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import java.awt.GridLayout;
import java.awt.BorderLayout;

/**
 * Classe construisant l'interface graphique  partir des vues/contrleurs et du modle.
 *
 * @author Christopher Henard
 * @version 27/10/2008
 */

public class Interface extends JFrame {

    //CHAMPS------------------------------------------------------
    static JTabbedPane tabbedPane;
    private JPanel settings;
    private Test test; //modle
    private LessonsView lessonsView; //vues - contrleurs
    private WordsView wordsView;
    private TestView testView;
    private ToolBar toolBar;
    private Menu menu;



    //CONSTRUCTEUR-----------------------------------------------
    /**
     * Cre et affiche l'interface graphique.
     * @param t le modele (test).
     */
    public Interface(Test t){
	super ("MTV - Minimum TOEIC Vocabulary");
	test = t;
	lessonsView = new LessonsView(test);
	wordsView = new WordsView(test);
	testView = new TestView(test);
	toolBar = new ToolBar(test);
	menu = new Menu(test);
	settings = new JPanel(new GridLayout(1,2));
	settings.setBorder(new TitledBorder("TOEIC Vocabulary")); 
	settings.add(lessonsView);
	settings.add(wordsView);
	tabbedPane = new JTabbedPane();
	tabbedPane.add("Settings",settings);
	tabbedPane.add("Test",testView);
	setJMenuBar(menu);
	getContentPane().add(tabbedPane);
	getContentPane().add(toolBar,BorderLayout.PAGE_START);
	setSize(680,550);
	setLocationRelativeTo(this.getParent());
	setResizable(false);
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	setVisible(true);	
    }
}// class Interface
	
