package mtv.gui;

import mtv.core.Test;
import java.util.Observer;
import java.util.Observable;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JTextPane;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;
import javax.swing.text.BadLocationException;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import javax.swing.JScrollPane;
import javax.swing.JOptionPane;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import static javax.swing.SwingConstants.CENTER;

/**
 * Classe reprsentant la vue des leons.
 *
 * @author Christopher Henard
 * @version 27/10/2008
 */

public class TestView extends JPanel implements Observer{ 

    //CHAMPS------------------------------------------------------
    private Test test;
    static JTextPane output;
    static JTextField input;
    private JScrollPane scrollPane;
    private JPanel top,middle,bottom;
    private JLabel remaining, reasking,wordsCount, errors;
    private String outputString;
    private String inputString;
    public static Style defaut, style1, style2, style3, style4, style5;
    public static StyledDocument sDoc;
    public static int pos;


    //CONSTRUCTEUR-----------------------------------------------
    /**
     * Construit la vue du test  partir du modle.
     * @param t le modele (le test).
     */
    public TestView(Test t){
	super(new BorderLayout());
	test = t;
	output = new JTextPane();
	defaut = output.getStyle("default");
	style1 = output.addStyle("style1", defaut);
	style2 = output.addStyle("style2", style1);
	style3 = output.addStyle("style3", style2);
	style4 = output.addStyle("style4", style3);
	style5 = output.addStyle("style(", style4);
	StyleConstants.setFontFamily(defaut, "Verdana");
	StyleConstants.setBold(defaut, true);
	StyleConstants.setBold(style1, false);
	StyleConstants.setBold(style2, true);
	StyleConstants.setItalic(style2, true);
	StyleConstants.setBold(style5, false);
	StyleConstants.setForeground(style2, Color.BLUE);
	StyleConstants.setForeground(style3, Color.GREEN);
	StyleConstants.setForeground(style4, Color.RED);
	StyleConstants.setItalic(style5, false);
	StyleConstants.setForeground(style5, Color.GRAY);
	StyleConstants.setFontSize(defaut, 12);
	sDoc = (StyledDocument)output.getDocument();
	input = new JTextField(58);
	input.setText("");
	inputString = "";
	top = new JPanel(new GridLayout(1,3));
	top.setBorder(new TitledBorder("Infos"));
	remaining = new JLabel(" Words remaining : " + (test.getCheckedWordsCount() - test.getAsked()),CENTER);
	errors=  new JLabel("Errors : "+ test.getErrors(),CENTER);
	top.add(remaining);	
	top.add(errors);

	output.setEditable(false);
	input.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
		    if (test.getCheckedWordsCount() > 0 ){
			if (! test.isFinished()){
			    try {
				String in = input.getText();
				test.setInput(in);
				test.answer();
				if (test.getEval())
				    sDoc.insertString(pos,in,style3);
				else
				    sDoc.insertString(pos,in,style4);
				pos+=in.length();
				String out = test.getOutput();
				if (! out.equals("\n") && ! test.isFinished()){
				    sDoc.insertString(pos,Test.errorMsg,style5); 
				    pos+=Test.errorMsg.length();
				    sDoc.insertString(pos,"\"",defaut); 
				    pos+=1;
				}
				sDoc.insertString(pos,out,style2);
				pos+=out.length();
				if (! out.equals("\n") && ! test.isFinished()){
				    sDoc.insertString(pos,"\"\n",defaut); 
				    pos+=2;
				}
				test.question();
				if (test.getLesson() != null){
				    TestView.sDoc.insertString(TestView.pos,"\n"+test.getLesson(),defaut);
				    pos+= test.getLesson().length()+1;
				    out = test.getOutput();
				    out = out+"\n";
				    String out1,out2,out3;
				    out1 = out.substring(0,out.indexOf('"')+1);
				    out2 = out.substring(out.indexOf('"')+1,out.lastIndexOf('"'));
				    out3 = out.substring(out.lastIndexOf('"'),out.length());	
				    TestView.sDoc.insertString(TestView.pos,out1,style1); 
				    TestView.pos += out1.length();
				    TestView.sDoc.insertString(TestView.pos,out2,style2);
				    TestView.pos += out2.length();
				    TestView.sDoc.insertString(TestView.pos,out3,style1);
				    TestView.pos += out3.length();
				    output.setCaretPosition(output.getDocument().getLength());
				    input.setText("");
				    remaining.setText(" Words remaining : " + (test.getCheckedWordsCount() - test.getAsked()));
				    errors.setText("Errors : "+ test.getErrors());
				}
				test.setOutput(null);
				test.setInput(null);
				test.setLesson(null);
			    } catch (BadLocationException ex) { }
			    input.setText("");
			}
		    }	
		}		    
	    });
	scrollPane = new JScrollPane(output);
	scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	scrollPane.setPreferredSize(new Dimension(640,302));
	scrollPane.setMinimumSize(new Dimension(640,342));
	middle = new JPanel();
	middle.setBorder(new TitledBorder("Output"));  // bordure de panneau
	middle.add(scrollPane);
	bottom = new JPanel();
	bottom.setBorder(new TitledBorder("Input"));  // bordure de panneau
	bottom.add(input);
	add(top,BorderLayout.NORTH);
	add(middle,BorderLayout.CENTER);
	add(bottom,BorderLayout.SOUTH);
	input.setFocusable(true);
	test.addObserver(this);
    }

    /**
     * Mthode de l'interface Observer, appele pour mettre  jour la vue.
     * @param o le modle (objet observ)
     * @param arg l'argument transmis par le modele (quand ses donnees changent) 
     * en argument de notifyObservers() (non utilis ici).
     */
    public void update(Observable o, Object arg){
	remaining.setText(" Words remaining : " + (test.getCheckedWordsCount() - test.getAsked()));
	errors.setText("Errors : "+ test.getErrors());
    }  
}//class TestView
