package mtv.gui;

import mtv.core.Test;
import java.util.Observer;
import java.util.Observable;
import java.io.IOException;
import java.io.PrintStream; 
import java.io.ByteArrayInputStream;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import javax.swing.JScrollPane;
import javax.swing.JOptionPane;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * Classe reprsentant la vue des leons.
 *
 * @author Christopher Henard
 * @version 27/10/2008
 */

public class TestView extends JPanel implements Observer{ 

    //CHAMPS------------------------------------------------------
    private Test test;
    static JTextArea output;
    private JTextField input;
    private JScrollPane scrollPane;
    private JPanel middle,bottom;
    private String inputString;



    //CONSTRUCTEUR-----------------------------------------------
    /**
     * Construit la vue du test  partir du modle.
     * @param t le modele (le test).
     */
    public TestView(Test t){
	super(new BorderLayout());
	test = t;
	output = new JTextArea(9,57);	
	input = new JTextField(58);
	input.setText("");
	inputString = "";
	output.setEditable(false);
	//redirection de la sortie standard sur un JTextArea.
	try{
	    System.setOut(new PrintStream(new TextAreaOutputStream(output),true,"ISO-8859-1"));
	}
	catch(IOException e){}
	input.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
		    if (test.getCheckedWordsCount() > 0 ){
			if (! test.isFinished()){
			    test.setInput(input.getText());
			    output.append(input.getText()+"\n");
			    test.answer();
			    test.question();
			    output.setCaretPosition(output.getDocument().getLength());
			    input.setText("");
			}
		    }	
		}		    
	    });
	scrollPane = new JScrollPane(output);
	scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	middle = new JPanel();
	middle.setBorder(new TitledBorder("Output"));  // bordure de panneau
	middle.add(scrollPane);
	bottom = new JPanel();
	bottom.setBorder(new TitledBorder("Input"));  // bordure de panneau
	bottom.add(input);
	add(middle,BorderLayout.CENTER);
	add(bottom,BorderLayout.SOUTH);
	test.addObserver(this);
    }

    /**
     * Mthode de l'interface Observer, appele pour mettre  jour la vue.
     * @param o le modle (objet observ)
     * @param arg l'argument transmis par le modele (quand ses donnees changent) 
     * en argument de notifyObservers() (non utilis ici).
     */
    public void update(Observable o, Object arg){// rien  mettre  jour
    }  
}//class TestView
