package mtv.gui;

import javax.swing.JTextArea;
import java.io.OutputStream; 
import java.io.IOException; 

/**
 * Classe permettant de rediriger la sortie standard sur un JTextArea.
 *
 * @author Christopher Henard
 * @version 27/10/2008
 */

public class TextAreaOutputStream extends OutputStream {
    //CHAMPS------------------------------------------------------
	private JTextArea textArea;
  
    //CONSTRUCTEUR-----------------------------------------------
    /**
     * Construit le flux de sortie sur le jtextarea.
     * @param textArea le jtextarea sur lequel sera redirig le flot de sortie standard.
     */
    public TextAreaOutputStream(JTextArea textArea){
	super() ;
	this.textArea = textArea;
    }
    

    //redfinition des mthodes d'criture d'outputstream
    // pour le jtextarea.
    /**
     * Ecrit un octet (byte)sur le flot de sortie.
     * @param b le byte.
     */
    @Override
	public void write(int b) throws IOException {
	textArea.append(new String(new byte[] { (byte) b }));
    }

    /**
     * Ecrit len bytes sur le flot de sortie  partir de l'indice off.
     * @param b le tableau de bytes.
     * @param off l'indice d'offset.
     * @param len le nombre de byte.
     */
    @Override
	public void write(byte[] b, int off, int len) throws IOException {
	textArea.append(new String(b, off, len));
    }
}//class TextAreaOutputStream
